unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, JvExComCtrls, JvComCtrls;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    lbDeviceStatus: TLabel;
    Memo1: TMemo;
    btOpen: TButton;
    btClose: TButton;
    btSetIRCode: TButton;
    btReadTrainedIRCode: TButton;
    btPowerOnEnabled: TButton;
    btPowerOnEnable: TButton;
    btPowerOnDisable: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    TrackBar_IR_Polling: TJvTrackBar;
    Label4: TLabel;
    btReadIrmpVersion: TButton;
    lbIrmpVersion: TLabel;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure OnButtonClick(Sender: TObject);
    procedure TrackBar_IR_PollingChange(Sender: TObject);
    procedure OnShow(Sender: TObject);
    procedure TrackBar_IR_PollingChanged(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormMain: TFormMain;
  IRPollingChanged : Boolean;

implementation

uses
  uHID;

{$R *.dfm}

procedure TFormMain.btCloseClick(Sender: TObject);
begin
  if Assigned(HIDThread) then
  begin
    HIDThread.Terminate;
    HIDThread.WaitFor;
    FreeAndNil(HIDThread);
    btOpen.Enabled := True;
    btClose.Enabled := False;
  end;
end;

procedure TFormMain.btOpenClick(Sender: TObject);
begin
  if not Assigned(HIDThread) then
  begin
    HIDThread := THIDThread.Create;
    HIDThreadID := HIDThread.ThreadID;
    HIDThread.VendorID := $16C0;
    HIDThread.ProductID := $05DF;
    HIDThread.PoolingDelay := StrToInt(Edit1.Text);
    HIDThread.Start;
    btOpen.Enabled := False;
    btClose.Enabled := True;
  end;
end;

procedure TFormMain.OnButtonClick(Sender: TObject);
begin
  if Sender = btPowerOnEnabled then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 0, ReadPowerOnEnabled);
  end
  else
  if Sender = btReadTrainedIRCode then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 0, ReadTrainendIRCode);
  end
  else
  if Sender = btPowerOnEnable then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 1, SetPowerOnEnabled);
  end
  else
  if Sender = btPowerOnDisable then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 0, SetPowerOnEnabled);
  end
  else
  if Sender = btSetIRCode then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 0, SetTrainedIRCode);
  end
  else
  if Sender = btReadIrmpVersion then
  begin
    PostThreadMessage(HIDThreadID, MessageToClientThread, 0, ReadIrmpVersion);
  end;
end;

procedure TFormMain.OnShow(Sender: TObject);
begin
  Label2.Caption := IntToStr(TrackBar_IR_Polling.Position) + 's';
end;

procedure TFormMain.TrackBar_IR_PollingChange(Sender: TObject);
begin
  Label2.Caption := IntToStr(TrackBar_IR_Polling.Position) + 's';
  IRPollingChanged := True;
end;

procedure TFormMain.TrackBar_IR_PollingChanged(Sender: TObject);
var
  newTime : Extended;
  OCR1A : Word;
begin
  newTime := (TrackBar_IR_Polling.Position / 1000000) / (1 / StrToInt(Edit2.Text));
  OCR1A := Trunc(newTime);
  PostThreadMessage(HIDThreadID, MessageToClientThread, OCR1A, SetIRPollingTime);
end;

end.
